/**
 * 版本号修改文件
 */
'use strict'
const path = require('path')
/* 
 1. fs.stat  检测是文件还是目录(目录 文件是否存在) 
 2. fs.mkdir  创建目录 （创建之前先判断是否存在） 
 3. fs.writeFile  写入文件(文件不存在就创建,但不能创建目录) 
 4. fs.appendFile 写入追加文件 
 5.fs.readFile 读取文件 
 6.fs.readdir 读取目录 
 7.fs.rename 重命名 
 8. fs.rmdir  删除目录 
 9. fs.unlink 删除文件 
*/
const fs = require('fs'); //fs是node.js的核心模块，不用下载安装，可以直接引入
const src = path.resolve(__dirname, '../src/U/js/U-config.js');
module.exports = {
	fs(){
		//10. fs.createReadStream  从文件流中读取数据，读取的文件比较大时建议用流的方式读取，文件比较大会多次读取。  
		var fileReadStream = fs.createReadStream(src);
		var str = '';
		fileReadStream.on('data', (data) => {
			str += data;
		})
		fileReadStream.on('end', () => {
			var reg3=/(#[^#]*#)/g;
			str = str.replace(reg3,"#v_"+new Date().valueOf()+"#");
			var writerStream = fs.createWriteStream(src);
			writerStream.write(str,'UTF8');
			writerStream.end();
		})
		fileReadStream.on('error', (error) => {
			console.log(error)
		})
	}
}