import request from '@/utils/request'
import moment from 'moment'

var baseMixin = {
	data() {
		return {
			buyerId: this.Cookies.get('buyerId'),
			openid: this.Cookies.get('openid'),
			Urls: {
				listUrl: '',
				formAddUrl: '',
				formUpdateUrl: '',
				deleteRowUrl: '',
				isExistUrl: '',
				statusUrl: ''
			}
		}
	},
	filters: {
		filterTime: function(value) {
			return moment(value).format('YYYY-MM-DD HH:mm:ss')
		},
	},
	watch: {},
	created() {},
	computed: {},
	methods: {
		pushHistory() {
			let state = {
				title: 'title',
				url: '#'
			};
			window.history.pushState(state, state.title, state.url);
		},
		gotoView(event) {
			console.log('进入了')
			let This = event.currentTarget;
			setTimeout(() => {
				This.scrollIntoView({
					block: 'end',
					behavior: 'smooth'
				});
			}, 500);
		},
		payMoney(id,fun) {
			let data = {
				openid: this.openid,
				orderId: id,
				status: '2',
				test: 1
			};
			request({
				url: this.Urls.payMoneyUrl,
				method: 'post',
				data
			}).then(response => {
				if (response.data.retHead.errCode == 0) {
					this.$router.push('/paySuccess');
				} else {
					this.$dialog.toast({
						mes: response.data.retHead.errMsg,
						icon: 'error',
						timeout: 1500
					});
				}
			});
		},
		wxPay(obj) {
			WeixinJSBridge.invoke(
				'getBrandWCPayRequest', {
					appId: obj.appId,
					timeStamp: obj.timeStamp,
					nonceStr: obj.nonceStr,
					package: obj.packageValue,
					signType: obj.signType,
					paySign: obj.paySign
				}, res => {
					if (res.err_msg == 'get_brand_wcpay_request:ok') {
						this.$router.push('/paySuccess');
					} else if (res.err_msg == 'get_brand_wcpay_request:cancel') {
						this.$router.push('/order');
					} else if (res.err_msg == 'get_brand_wcpay_request:fail') {

					}
				}
			);
		}
	}

};

export default baseMixin;
