import router from '../router';
import axios from 'axios'
import qs from 'qs'
import {
	getToken
} from '@/utils/auth'



// create an axios instance
const service = axios.create({
	baseURL:window.U.sCon.host,
	timeout: 5000, // request timeout
});

// request interceptor
service.interceptors.request.use(config => {
	config.headers['accessToken'] = getToken(); // 让每个请求携带token-- ['X-Token']为自定义key 请根据实际情况自行修改
	return config
}, error => {
	//console.log(error);
	Promise.reject(error)
});
var againLogin = false;
// respone interceptor
service.interceptors.response.use(response => {
	// alert(JSON.stringify(response));
	if (response.data.retHead.errCode == 402 || response.data.retHead.errCode == 403 || response.data.retHead.errCode == 405) {
		//U.E(response.data.retHead.errMsg);
		router.replace({
			name: 'login',
			params:response.data.retHead
		});
		return
	}else if(response.data.retHead.errCode == 404){
		U.E(response.data.retHead.errMsg);
		router.replace({
			name: 'login',
			params:response.data.retHead
		});
		return
	}
	return response
}, (error,q,b,c) => {
	return Promise.reject(error);
})

export default service
