import request from '@/utils/request'
import moment from 'moment'

var indexMixin = {
	data() {
		return {
			defaultImg: 'this.src="' + require('@/assets/img/default.png') + '"',
			buyerId: this.Cookies.get('buyerId'),
			openid: this.Cookies.get('openid'),
			Urls: {
				listUrl: '/frequentShoppingLists/list',
				delUrl: '/frequentShoppingLists'
			},
			list: [],
			checklist: [],
			isCheckAll: false,
			optShow: true,
			goodsNum: 0
		}
	},
	filters: {},
	watch: {},
	created() {
		if (this.$route.query.add == 'false') {
			this.optShow = false
		}
		this.getList();
	},
	computed: {},
	methods: {
		getList() {
			this.$dialog.loading.open('正在加载');
			let data = {
				pageNum: 1,
				pageSize: 1000,
				userId: this.buyerId
			}
			request({
				url: this.Urls.listUrl,
				method: 'post',
				data
			}).then(response => {
				this.$dialog.loading.close();
				if (response.data.retHead.errCode == 0) {
					this.list = response.data.retBody.list;
					this.checklist = [];
				} else {
					this.$dialog.toast({
						mes: response.data.retHead.errMsg,
						icon: 'error',
						timeout: 1500
					});
				}
			});
		},
		changeCheck(value, isCheckAll) {
			this.isCheckAll = isCheckAll;
			this.goodsNum = this.checklist.length;
		},
		checkAll() {
			this.isCheckAll = this.isCheckAll == true?false:true;
			this.$refs.checklist.$emit('ydui.checklist.checkall', this.isCheckAll);
		},
		addBills() {
			this.$router.push({
				path: '/goodsList',
				query: {
					type: 'add'
				}
			})
		},
		delBills() {
			if (this.checklist.length == 0) {
				this.$dialog.toast({
					mes: '请选择你要删除的商品',
					icon: 'none',
					timeout: 1500
				});
				return;
			}
			this.$dialog.confirm({
				title: '删除商品',
				mes: '您确定要删除吗！！！',
				opts: () => {
					this.$dialog.loading.open('正在删除中');
					let data = {
						userId: this.buyerId,
						productIds: this.checklist
					}
					request({
						url: this.Urls.delUrl,
						method: 'delete',
						data
					}).then(response => {
						this.$dialog.loading.close();
						if (response.data.retHead.errCode == 0) {
							this.getList();
						} else {
							this.$dialog.toast({
								mes: response.data.retHead.errMsg,
								icon: 'error',
								timeout: 1500
							});
						}
					});
				}
			});
		},
		getPrice() {
			if (this.checklist.length == 0) {
				this.$dialog.toast({
					mes: '请选择你要报价的商品',
					icon: 'none',
					timeout: 1500
				});
				return;
			}
			//把当前选择需求获取报价的商品保存到缓存对象
			this.$session.set('priceObj', {
				keys:this.checklist
			});
			this.$router.push('/goodsPrice');
		},
	}
};

export default indexMixin;
