import request from '@/utils/request'
import moment from 'moment'

var indexMixin = {
	data() {
		return {
			activeClass: 0,
			name: '',
			checklist: [],
			typeList: [{
					"Bid": "88",
					"name": "全部商品",
					goodsList: []
				},
				{
					"Bid": "99",
					"name": "最近购买",
					goodsList: []
				}
			],
			list: [],
			defaultImg: 'this.src="' + require('@/assets/img/default.png') + '"',
			pageNum: 1,
			pageSize: 10,
			Urls: {
				listUrl: '/product/findProductType',
				productUrl: '/product/findProductByType',
				recendPurchaseUrl: '/product/recently',
				getPriceListUrl: '/product/findProductByIds',
				billUrl: '/frequentShoppingLists',
			},
			productIds: []
		};
	},
	filters: {},
	watch: {},
	created() {
		//获取类型列表
		this.getList();
	},
	mounted() {
		//获取初始全部商品
		this.getProduct(0);
	},
	computed: {},
	methods: {
		//搜索
		submitHandler() {
			this.getProduct(0);
		},
		//取消搜索
		cancelHandler() {
			this.name = '';
			this.submitHandler('');
		},
		//取得分类列表
		getList() {
			request({
				url: this.Urls.listUrl,
				method: 'get'
			}).then(res => {
				if (res.data.retHead.errCode == 0) {
					//取得分类列表
					const _list = res.data.retBody.list;
					this.typeList = [...this.typeList, ..._list];
					this.typeList = this.typeList.map(v => {
						//已选择数组
						this.$set(v, 'goodsList', []);
						return v;
					});
				} else {
					this.$dialog.toast({
						mes: res.data.retHead.errMsg,
						icon: 'error',
						timeout: 1500
					});
				}
			});
		},
		//获取商品列表
		getProduct(index, id) {
			//当index==undefined 滚动加载
			if (index != undefined) {
				this.pageNum = 1;
				this.list = [];
				//保存首次滚动加载类型列表下标
				this.activeClass = index || 0;
				//初始化滚动加载
				this.$refs.infinitescrollDemo.$emit('ydui.infinitescroll.reInit');
				this.bigTypeId = id || '';
			}
			this.checklist = [];
			id && this.Cookies.set('bigTypeId', id);
			let data = {
				bigTypeId: this.bigTypeId,
				pageNum: this.pageNum,
				pageSize: this.pageSize,
				buyerId: this.activeClass == 1 ? this.buyerId : '',
				name: this.name || "", //搜索条件
			};
			this.$dialog.loading.open('正在加载');
			request({
				url: this.activeClass == 1 ? this.Urls.recendPurchaseUrl : this.Urls.productUrl,
				method: 'post',
				data
			}).then(res => {
				this.$dialog.loading.close();
				//取得全部商品
				if (res.data.retHead.errCode == 0) {
					const _list = res.data.retBody.list;
					//去重合并数组
					this.list = [...this.list, ..._list];
					//取得已经选中数组
					this.checklist = this.typeList[this.activeClass]['goodsList'] || [];
					if (res.data.retBody.total < (this.pageSize * this.pageNum)) {
						/* 所有数据加载完毕 */
						this.$refs.infinitescrollDemo.$emit('ydui.infinitescroll.loadedDone');
						return;
					}
					/* 单次请求数据完毕 */
					this.$refs.infinitescrollDemo.$emit('ydui.infinitescroll.finishLoad');
					this.pageNum++;
				} else {
					this.$dialog.toast({
						mes: res.data.retHead.errMsg,
						icon: 'error',
						timeout: 1500
					});
				}
			});
		},
		//动态变化数量，合并选中项到所有商品
		change(item) {
			let index = this.activeClass,
				value = item.id,
				_typelist = this.typeList;
			//判定最近购买
			if (index == 1) {
				//查找所有类别并删除
				for (let i = 2; i < _typelist.length; i++) {
					let _index = _typelist[i]['goodsList'].indexOf(value);
					if (_index != -1) {
						_typelist[i]['goodsList'].splice(_index, 1);
						break;
					} else {
						_typelist[i]['goodsList'].push(value);
						break;
					}
				}
			} else {
				//查找并删除最近购买数组
				let _index = _typelist[1]['goodsList'].indexOf(value);
				_index == -1 ? _typelist[1]['goodsList'].push(value) : _typelist[1]['goodsList'].splice(_index, 1);
			}
			if (index == 0) {
				//取得当前商品大类id
				for (let i = 0; i < _typelist.length; i++) {
					if (_typelist[i].id == item.productBigTypeId) {
						index = i;
						break;
					}
				}
			}

			let _index = _typelist[index]['goodsList'].indexOf(value);
			_index == -1 ? _typelist[index]['goodsList'].push(value) : _typelist[index]['goodsList'].splice(_index, 1);
			//合并显示全部商品
			let concatArr = [];
			for (let i = 1; i < _typelist.length; i++) {
				concatArr = concatArr.concat(_typelist[i]['goodsList'] || []);
			}
			this.typeList[0]['goodsList'] = [...new Set(concatArr)];

		},
		//获取报价
		getPrice() {
			this.productIds = this.allbill();
			//把当前选择需求获取报价的商品保存到缓存对象
			this.$session.set('priceObj', {
				keys:this.productIds
			});
			this.productIds.length?this.$router.push('/goodsPrice'):this.$dialog.toast({
                    mes: '你还没有选择商品噢！！！',
                    timeout: 1500
                });
		},
		addBill() {
			this.productIds = this.allbill();
			this.getBill();
		},
		allbill() {
			let list = this.typeList,
				productIds = [];
			for (let i = 0; i < list.length; i++) {
				productIds = productIds.concat(list[i]['goodsList'] || []);
			}
			//去重
			for (let index = 0; index < productIds.length;) {
				let item = productIds[index];
				if (item) {
					for (let i = ++index; i < productIds.length; item == productIds[i] ? productIds.splice(i, 1) : i++) {}
				}
			}
			if (productIds.length == 0) {
				this.$dialog.toast({
					mes: '请选择你要报价的商品',
					icon: 'none',
					timeout: 1500
				});
				return;
			}
			return productIds;
		},
		getBill() {
			this.optShow = false;
			this.$dialog.loading.open('正在加载');
			let data = {
				userId: this.buyerId,
				productIds: this.productIds
			}
			request({
				url: this.Urls.billUrl,
				method: 'post',
				data
			}).then(res => {
				this.$dialog.loading.close();
				if (res.data.retHead.errCode == 0) {
					this.$router.push({
						path: '/bill',
						query: {
							add: false
						}
					});
				} else {
					this.$dialog.toast({
						mes: res.data.retHead.errMsg,
						icon: 'error',
						timeout: 1500
					});
				}
			});
		},
	}
};

export default indexMixin;
